﻿Public Class Form1

    ' Weitere Ordner die verwendet werden können, falls es diese auf dem PC gibt.
    ' https://www.autohotkey.com/docs/v1/misc/CLSID-List.htm
    ' https://winaero.com/clsid-guid-shell-list-windows-10/
    ' "https://www.magnumdb.com/search?q=FOLDERID_*"

    Private Const CLSID_HomeFolder As String = "::{679f85cb-0220-4080-b29b-5540cc05aab6}" 'Schnellzugriff
    Private Const CLSID_MyComputer As String = "::{20d04fe0-3aea-1069-a2d8-08002b30309d}" 'Dieser PC

    ' für die Beispiele was noch geht 
    Private Const CLSID_Printers As String = "::{2227a280-3aea-1069-a2de-08002b30309d}" 'Drucker
    Private Const FOLDERID_Fonts As String = "{fd228cb7-ae11-4ae3-864c-16f3910ab8fe}" 'Fontordner
    Private Const MyPath As String = "C:\Windows"

    Private WithEvents NSTV As New NameSpaceTreeView

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim Style As NameSpaceTreeView.NSTCSTYLE = NameSpaceTreeView.NSTCSTYLE.NSTCS_BORDER Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_HASEXPANDOS Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_ROOTHASEXPANDO Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_FADEINOUTEXPANDOS Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_ALLOWJUNCTIONS Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_SHOWSELECTIONALWAYS Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_FULLROWSELECT Or
                                                   NameSpaceTreeView.NSTCSTYLE.NSTCS_HORIZONTALSCROLL

        If NSTV.Initialize(Me.Handle, New Rectangle(10, 10, Me.ClientSize.Width - 10, Me.ClientSize.Height - 10), Style) Then

            ' Optionale Eigenschaften
            'NSTV.SetBackColor(Color.AliceBlue)
            'NSTV.SetTextColor(Color.Green)
            'NSTV.SetItemHeight(23)
            NSTV.SetControlStyle2(NameSpaceTreeView.NSTCSTYLE2.NSTCS2_DISPLAYPADDING,
                                  NameSpaceTreeView.NSTCSTYLE2.NSTCS2_DISPLAYPADDING)

            ' Shell-Objekte die im TreeView angezeigt werden sollen
            NSTV.AppendRoot(CLSID_HomeFolder,
                            NameSpaceTreeView.SHCONTF.SHCONTF_FOLDERS,
                            NameSpaceTreeView.NSTCROOTSTYLE.NSTCRS_EXPANDED)

            NSTV.AppendRoot(CLSID_MyComputer,
                            NameSpaceTreeView.SHCONTF.SHCONTF_FOLDERS,
                            NameSpaceTreeView.NSTCROOTSTYLE.NSTCRS_EXPANDED,
                            NameSpaceTreeView.NSTCITEMSTATE.NSTCIS_SELECTED,
                            NameSpaceTreeView.NSTCITEMSTATE.NSTCIS_SELECTED)

            'Beispiele was noch geht
            'NSTV.AppendRoot(MyPath,
            '                NameSpaceTreeView.SHCONTF.SHCONTF_FOLDERS,
            '                NameSpaceTreeView.NSTCROOTSTYLE.NSTCRS_EXPANDED)

            'NSTV.AppendRoot(CLSID_Printers,
            '                NameSpaceTreeView.SHCONTF.SHCONTF_NONFOLDERS,
            '                NameSpaceTreeView.NSTCROOTSTYLE.NSTCRS_EXPANDED)

            'NSTV.AppendRoot(FOLDERID_Fonts,
            '                NameSpaceTreeView.SHCONTF.SHCONTF_NONFOLDERS,
            '                NameSpaceTreeView.NSTCROOTSTYLE.NSTCRS_EXPANDED)

        End If
    End Sub

    Private Sub Form1_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        NSTV.Resize(New Rectangle(10, 10, Me.ClientSize.Width - 10, Me.ClientSize.Height - 10))
    End Sub

    Private Sub NSTV_SelectionChanged(Items As List(Of String)) Handles NSTV.SelectionChanged
        Dim Count As Integer = Items.Count
        If Count > 0 Then
            For Item As Integer = 0 To Count - 1
                Debug.Print(Items(Item))
            Next
        End If
    End Sub
End Class
